//
//  Item.m
//  Closet2
//
//  Created by Sarah Hawi on 3/10/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "Item.h"


@implementation Item

@synthesize category, weather, formal, available,colorr,imageKey, image, chosen;
- (id)initWithCoder:(NSCoder *)decoder
{
	if (self = [super init])
	{
	//	seed
		self.category = [decoder decodeObjectForKey:@"category"];
		self.colorr = [decoder decodeObjectForKey:@"color"];
		self.weather = [decoder decodeObjectForKey:@"weather"];
		self.available= [decoder decodeBoolForKey:@"available"];
		self.formal= [decoder decodeBoolForKey:@"formal"];
		self.imageKey= [decoder decodeObjectForKey:@"imageKey"];
		self.chosen = NO;
		NSLog(@"The image key is %@",self.imageKey);
		[self image];

	}
	return self;
	
}
/*- (id)category:(NSString *) category weather:(NSString *)weather available:(BOOL) available formal:(BOOL)formal;
{
	if ([super init]) {
		self.category = category;
		self.weather = weather;
		self.formal = formal;
		self.available=available;
	}
	return self;
}*/

//- (id)init
//{
	//return [self initWithPossessionName:@"Possession"];
//}



- (UIImage *)image;
{
	if (!image)
	{
		NSLog(@"No image loaded yet, do it now for imageKey %@",self.imageKey);
		NSString *docDir = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];	
		// If you go to the folder below, you will find those pictures
		NSString *pngFilePath = [docDir	stringByAppendingPathComponent:[NSString stringWithFormat:@"%@.png",self.imageKey]];
		NSLog(@"Available Files");
		// Create file manager
		NSError *error;
		NSFileManager *fileMgr = [NSFileManager defaultManager];
		
		// Point to Document directory
		NSString *documentsDirectory = [NSHomeDirectory() stringByAppendingPathComponent:@"Documents"];
		
		// Write out the contents of home directory to console
		NSLog(@"Documents directory: %@", [fileMgr contentsOfDirectoryAtPath:documentsDirectory error:&error]);
		
		//NSData *data1 = [NSData dataWithContentsOfFile:pngFilePath];
		image = [[UIImage alloc] initWithContentsOfFile:pngFilePath];
		
	}
	else {
		NSLog(@"Image already loaded");
	}

	return image;
}

- (void)setImage:(UIImage *)theImage;
{
	// TODO: Write image to file with filename imageKey
	[self willChangeValueForKey:@"image"];
	if (!image){
		image = [theImage retain];
	}
	else {
		[theImage retain];
		[image release];
		image = theImage;
	}
	[self didChangeValueForKey:@"image"];
	
	NSString *docDir = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];	
	// If you go to the folder below, you will find those pictures
	NSString *pngFilePath = [docDir	stringByAppendingPathComponent:[NSString stringWithFormat:@"%@.png",self.imageKey]];
	NSLog(@"Saving image to file %@",pngFilePath);
	[UIImagePNGRepresentation(image) writeToFile:pngFilePath atomically:YES];
	
	//[NSString stringWithFormat:@"%@/images/%@.png",docDir,self.imageKey];
	//NSData *data1 = [NSData dataWithData:UIImagePNGRepresentation(theImage)];
	//[data1 writeToFile:pngFilePath atomically:YES];
}

- (void)dealloc
{   [imageKey release];
	[colorr release];
	[category release];
	[weather release];
	[image release];
	[super dealloc];
}


#pragma mark Description

#pragma mark NSCoding Methods

- (void)encodeWithCoder:(NSCoder *)encoder
{   [encoder encodeObject:self.imageKey forKey:@"imageKey"];
	[encoder encodeObject:self.category forKey:@"category"];
	[encoder encodeObject:self.colorr forKey:@"color"];
	[encoder encodeObject:self.weather forKey:@"weather"];
	[encoder encodeBool:self.available forKey:@"available"];
	[encoder encodeBool:self.formal forKey:@"formal"];	
	
}



@end
